<div class="display-container collapsable collapsed{% if writable %} menu{% endif %}">
    <div class="header communication-state warning-state format-source" instrument="Campbell CR1000"></div>

    {% include 'acquisition/display/header_buttons.html' %}

    {% if writable %}
    <div class="menu communication-state hide-false">
        <button class="menu mdi mdi-menu" title="Instrument actions"></button>
        <ul class="menu menu-below">
            <li><button id="{{uid}}_set_digital">Change digital output</button></li>
            <li><button id="{{uid}}_set_analog">Change analog output</button></li>
        </ul>
    </div>
    {% endif %}

    {% include 'acquisition/display/nocommunication_content.html' %}

    <table class="content display-data communication-state hide-false">
        <tbody>
            <tr> <td>Board temperature (°C)</td>    <td class="value-formatted" field="T" rightpad="2"></td> </tr>
            <tr> <td>Supply voltage (V)</td>        <td class="value-formatted" field="V" decimals="3"></td> </tr>
            <tr> <td>Digital state</td>             <td class="value-hex" field="digital" rightpad="4"></td> </tr></td> </tr>
        </tbody>
    </table>

    <table class="content display-data column-split communication-state hide-false">
        <thead>
            <tr>
                <th colspan="2">Channel</th>
                <th>Value</th>
                <th>Raw (V)</th>
            </tr>
        </thead>
        <tbody id="{{uid}}_channels">
        </tbody>
    </table>

</div>

<style>
#{{uid}}_channels > tr td:nth-child(1) {
  min-width: 0;
  text-align: right;
  font-family: monospace;
}
#{{uid}}_channels > tr td:nth-child(2) {
  text-align: left;
  min-width: 0;
}
</style>

<script>
(function() {
    const context = document.getElementById('{{uid}}').context;
    context.standardMode();

    const channelDisplay = document.getElementById('{{uid}}_channels');
    let outputNames = undefined;
    let digitalNames = undefined;
    let outputValues = undefined;
    let digitalState = undefined;

    function getRow(index) {
        if (index < channelDisplay.children.length) {
            return channelDisplay.children[index];
        }

        const tr = channelDisplay.insertRow();
        for (let i=0; i<4; i++) {
            tr.insertCell();
        }
        tr.children[0].textContent = (index+1).toString();
        return tr;
    }

    context.addInstrumentPresent((source, info) => {
        outputNames = info.output;
        digitalNames = info.digital;
        const variable = info.variable;
        for (let i=0; i<variable.length; i++)  {
            getRow(i).children[1].textContent = variable[i] || '';
        }
    }, context.source);

    context.addSourceTarget((value) => {
        if (!value || !value.length) {
            return;
        }
        for (let i=0; i<value.length; i++)  {
            const v = value[i];
            if (v === null || !isFinite(v)) {
                continue;
            }
            getRow(i).children[2].textContent = (v * 1.0).toFixed(3);
        }
    }, context.source, 'value');
    context.addSourceTarget((value) => {
        if (!value || !value.length) {
            return;
        }
        for (let i=0; i<value.length; i++)  {
            const v = value[i];
            if (v === null || !isFinite(v)) {
                continue;
            }
            getRow(i).children[3].textContent = (v * 1.0).toFixed(3);
        }
    }, context.source, 'raw');
    context.addSourceTarget((value) => {
        if (!value || !value.length) {
            return;
        }
        outputValues = value;
    }, context.source, 'output');
    context.addSourceTarget((value) => {
        digitalState = value;
    }, context.source, 'digital');

    $('#{{uid}}_set_analog').click(function(event) {
        event.preventDefault();

        const channelData = [];
        for (let index=0; index<10; index++) {
            let name = index.toFixed();
            if (outputNames && outputNames[index]) {
                name = name + "(" + outputNames[index] + ")";
            }

            let value = undefined;
            if (outputValues) {
                value = outputValues[index];
                if (value === null || !isFinite(value)) {
                    value = undefined;
                } else {
                    value = (value * 1).toFixed(3);
                }
            }

            channelData.push({
                channel: index,
                display: name,
                placeholder: value,
            });
        }

        ACTION_PROMPT_DATA = {
            source: context.source,
            channels: channelData,
        };
        showModal("{{ request.url_for('static', path='/modal/setanalogchannel.html') }}");
    });
    $('#{{uid}}_set_digital').click(function(event) {
        event.preventDefault();

        ACTION_PROMPT_DATA = {
            source: context.source,
            bits: 16,
            value: digitalState,
            channels: digitalNames,
        };
        showModal("{{ request.url_for('static', path='/modal/setdigitaloutput.html') }}");
    });
})();
</script>